# ############################################################################
# Neptune_Reboot v0.1.4
# Author CmG Neptune
# Date: 09/20/2010
# ############################################################################
# ############################################################################
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# ############################################################################

# ####################################################
# Pick a time to restart the server
# Choose times using 0 - 23 for hours of 12am - 11pm
# Reboots will be done as soon as possible once it
# has reached past the time set.
# ####################################################
restartAtHour = 7 # 0 - 23 
restartAtMins = 0 # 0 - 59
rebootWindow = 10 # number of minutes for reboot window will not reboot past this window


# ####################################################
# Do not edit below this line
# ####################################################


# Import the modules we need
import es
import os
import time
import gamethread
import playerlib

#Name and information of the mod
modName = "[#greenNeptune's Reboot#default]"
modVersion = "v 0.1.4"
modAuthor = "Neptune"
modPath = "./cstrike/addons/eventscripts/neptune_reboot/"
modLogPath = "./cstrike/logs/neptune_reboot/"
modCfgPath = "./cstrike/cfg/neptune_reboot/"


restartAtTime = restartAtHour * 60
restartAtTime = restartAtTime + restartAtMins



# Actions to take when the mod is loaded
def load():
 varsetDelay = 60 * int(rebootWindow) + 1
 es.set("neptune_reboot_time", restartAtTime)
 es.set("neptune_reboot_status", "wait")
 gamethread.delayed(varsetDelay, es.set, ('neptune_reboot_status', 'reboot'))
 checkPaths()
 neptune_log("Mod Loaded")
 es.msg("#multi", modName + " loaded.")

def round_start(event_var):
 checkTimer()

def checkTimer():
 playerlist = playerlib.getPlayerList("#human")
 if(len(playerlist) < 1):
  gamethread.delayedname(60, "neptune_reboot_timer_loop",checkTimer)
 theHour = int(time.strftime("%H", time.localtime()))
 theMinute = int(time.strftime("%M", time.localtime()))
 theTime = theHour * 60 + theMinute
 rebootBy = int(restartAtTime) + int(rebootWindow)
 if(int(restartAtTime) <= int(theTime) and int(theTime) < int(rebootBy)):
  if(es.ServerVar("neptune_reboot_status") == "reboot"):
    runRestart()

def runRestart():
  es.set("neptune_reboot_status", "rebooting")
  neptune_log("Mod Initiated Restart")
  es.msg("#multi", modName + " Server Restarting in 30 seconds.")
  gamethread.delayed(5, es.msg, ("#multi", modName + " Server Restart in 25 seconds"))
  gamethread.delayed(10, es.msg, ("#multi", modName + " Server Restart in 20 seconds"))
  gamethread.delayed(15, es.msg, ("#multi", modName + " Server Restart in 15 seconds"))
  gamethread.delayed(20, es.msg, ("#multi", modName + " Server Restart in 10 seconds"))
  gamethread.delayed(25, es.msg, ("#multi", modName + " Server Restart in 5 seconds"))
  gamethread.delayed(30, es.msg, ("#multi", modName + " Server Restart NOW!"))
  gamethread.delayed(31, es.server.cmd, ("_restart"))

def es_map_start(event_var):
 gamethread.delayed(30, es.msg, ("#multi", modName + " version: %s by %s is running." % (modVersion, modAuthor)))
 checkTimer()

def neptune_log(arg):
 timestamp = time.strftime("%m/%d/%y - %H:%M:%S", time.localtime())
 mdytimestamp = time.strftime("%m_%Y", time.localtime())
 myLog = open(modLogPath + mdytimestamp +".log", "a")
 myLog.write("[" + timestamp + "] " + arg + "\n")
 myLog.close()

def checkPaths():
 if(os.path.exists(modLogPath) == False):
  os.mkdir(modLogPath)
  neptune_log("Log Path Created")
 if(os.path.exists(modCfgPath) == False):
  os.mkdir(modCfgPath)
  neptune_log("Config Path Created")

def player_disconnect(event_var):
 gamethread.delayed(2,checkTimer)

# Actions to take as the mod is unloaded
def unload(): 
 neptune_log("Mod Unloaded")
 es.msg("#multi",modName + " unloaded.")